var playerDefeated = [0,0,0,0,0,0,0,0,0,0,0,0];
var powerTimer = [0,0];

//Set missing players' playerDefeated flags to 1 so that the "player defeated" message doesn't play on game start.
function setDefeatedPlayers() {
	for (var playnum = 0; playnum < maxPlayers; playnum++) {
		var factories = enumStruct(playnum,CYBORG_FACTORY).length + enumStruct(playnum,FACTORY).length + enumStruct(playnum,VTOL_FACTORY).length;
		var droids = enumDroid(playnum).length;
		if (factories == 0 && droids == 0)
			playerDefeated[playnum] = 1;
	}
}

//Display miscellaneous situations to player that cannot be called by other known events.
function sitRepCheckup() {
	//Power Checkup
	if (playerPower(selectedPlayer) < 1 && gameTime > powerTimer[0]+15000) {
		playSound(SOUND_POWER_LOW); //Warn the player that his/her power is low.
		powerTimer[0] = gameTime;
	}
	if (enumStruct(selectedPlayer,RESOURCE_EXTRACTOR).length > enumStruct(selectedPlayer,POWER_GEN).length*4 && gameTime > powerTimer[1]+15000) {
		playSound(SOUND_NEED_GENERATORS); //Warn the player that he/she needs more power generators.
		powerTimer[1] = gameTime;
	}

	//LasSat Readiness Checkup
	/*var list=enumStruct(selectedPlayer,"A0LasSatCommand");
	if (list.length>0) {
		for (var i=0; i<list.length; ++i) {
			if (list[i].status == BUILT && structureIdle(list[i])) {
				if (gameTime > lassatReadyTime + 10000) {
					playSound(SOUND_LASSAT_READY, list[i].x, list[i].y, list[i].z);
					lassatReadyTime = gameTime;
					break;
				}
			}
		}
	}*/

	//End Conditions Checkup
	var factories;
	var droids;
	for (var playnum = 0; playnum < maxPlayers; ++playnum) {
		factories = enumStruct(playnum,CYBORG_FACTORY).length + enumStruct(playnum,FACTORY).length + enumStruct(playnum,VTOL_FACTORY).length;
		droids = enumDroid(playnum).length;
		if (droids == 0 && factories == 0) { //The player has been knocked out.
			if (playerDefeated[playnum] == 0) {
				playerDefeated[playnum] = 1;
				if (playnum==selectedPlayer)
					playSound(SOUND_PLAYER_DEFEATED);
				else if (playnum != selectedPlayer && allianceExistsBetween(playnum,selectedPlayer))
					playSound(SOUND_ALLY_DEFEATED);
				else if (playnum != selectedPlayer && !allianceExistsBetween(playnum,selectedPlayer))
					playSound(SOUND_ENEMY_DEFEATED);
			}
		}
		else { //The player has been revived.
			if (playerDefeated[playnum] == 1) {
				playerDefeated[playnum] = 0;
				if (playnum==selectedPlayer)
					playSound(SOUND_PLAYER_REVIVED);
				else if (playnum != selectedPlayer && allianceExistsBetween(playnum,selectedPlayer))
					playSound(SOUND_ALLY_REVIVED);
				else if (playnum != selectedPlayer && !allianceExistsBetween(playnum,selectedPlayer))
					playSound(SOUND_ENEMY_REVIVED);
			}
		}
	}
}