var lastDetectTime = [0,0,0,0,0,0,0,0,0];

function sitRepDetected(viewer, detectedObj) {
	//Does the viewer belong to either the player or one of his/her allies, and is the detected object an enemy object?
	if (detectedObj.player != selectedPlayer && !allianceExistsBetween(selectedPlayer,detectedObj.player) && (viewer.player == selectedPlayer || allianceExistsBetween(selectedPlayer,viewer.player))) {
		if (detectedObj.type == DROID) { //Enemy unit detected
			if (detectedObj.player == scavengerPlayer) { //Scavenger unit detected
				if (gameTime > lastDetectTime[0] + 10000) {
					playSound(SOUND_UNIT_DETECTED_SCAV, detectedObj.x, detectedObj.y, detectedObj.z);
					lastDetectTime[0] = gameTime;
				}
			}
			else if (detectedObj.droidType == DROID_TRANSPORTER || detectedObj.droidType == DROID_SUPERTRANSPORTER) { //Enemy transport detected
				if (gameTime > lastDetectTime[1] + 10000) {
					playSound(SOUND_TRANSPORT_DETECTED, detectedObj.x, detectedObj.y, detectedObj.z);
					lastDetectTime[1] = gameTime;
				}
			}
			else if (detectedObj.isVTOL) { //Enemy VTOL detected
				if (gameTime > lastDetectTime[2] + 10000) {
					playSound(SOUND_VTOL_DETECTED, detectedObj.x, detectedObj.y, detectedObj.z);
					lastDetectTime[2] = gameTime;
				}
			}
			else if (detectedObj.hasIndirect && detectedObj.range > 2000) { //Enemy artillery detected. NOTE: We need to exclude the more short-ranged indirect-fire units, like Mini-Rocket Arrays.
				if (gameTime > lastDetectTime[3] + 10000) {
					playSound(SOUND_ARTILLERY_DETECTED, detectedObj.x, detectedObj.y, detectedObj.z);
					lastDetectTime[3] = gameTime;
				}
			}
			else { //Play generic enemy unit detected sound
				if (gameTime > lastDetectTime[4] + 10000) {
					playSound(SOUND_UNIT_DETECTED, detectedObj.x, detectedObj.y, detectedObj.z);
					lastDetectTime[4] = gameTime;
				}
			}
		}
		else if (detectedObj.type == STRUCTURE && detectedObj.stattype != WALL && detectedObj.stattype != GATE) { //Enemy structure detected (excluding walls or gates)
			if (detectedObj.player == scavengerPlayer && !(detectedObj.hasIndirect && detectedObj.range > 2000)) { //Scavenger structure detected
				if (detectedObj.stattype == DEFENSE) { //Scavenger defense detected
					if (gameTime > lastDetectTime[5] + 10000) {
						playSound(SOUND_STRUCT_DETECTED_SCAV_DEF, detectedObj.x, detectedObj.y, detectedObj.z);
						lastDetectTime[5] = gameTime;
					}
				}
				else { //Scavenger base detected
					if (gameTime > lastDetectTime[6] + 10000) {
						playSound(SOUND_STRUCT_DETECTED_SCAV, detectedObj.x, detectedObj.y, detectedObj.z);
						lastDetectTime[6] = gameTime;
					}
				}
			}
			else if (detectedObj.hasIndirect && detectedObj.range > 2000) { //Enemy artillery detected. NOTE: We need to exclude the more short-ranged indirect-fire units, like Mini-Rocket Arrays.
				if (gameTime > lastDetectTime[7] + 10000) {
					playSound(SOUND_ARTILLERY_DETECTED, detectedObj.x, detectedObj.y, detectedObj.z);
					lastDetectTime[7] = gameTime;
				}
			}
			else { //Enemy player's structure detected
				if (gameTime > lastDetectTime[8] + 10000) {
					playSound(SOUND_STRUCT_DETECTED, detectedObj.x, detectedObj.y, detectedObj.z);
					lastDetectTime[8] = gameTime;
				}
			}
		}
	}
}