
	/********************************/
	/* Generic branch specific code */
	/********************************/

function constructPersonality() {
		
	this.MIN_BUILDERS = 2;		// the usual number of trucks that construct base structures
	this.MAX_BUILDERS = 2;		// the maximum number of trucks that construct base structures
	this.MIN_OILERS = 8;		// the usual number of trucks used for oil hunting
	this.MAX_OILERS = 8;		// the maximum number of trucks used for oil hunting
	this.MIN_DEFENDERS = 0;		// the minimum number of tanks before producing more trucks than necessary
	this.DEFENSIVENESS = 0;		// regulates chance of spending money on defensive structures
	this.PEACE_TIME = 0;		// the amount of minutes for free scouting (regrouping disabled, no defenses built)

	this.THIS_AI_MAKES_TANKS = false;
	this.THIS_AI_MAKES_CYBORGS = false;
	this.THIS_AI_MAKES_VTOLS = true;
	
	// override the global to make use of multiple different research facilities
	repair = [
		"A0RepairCentre4", // repair facility 4
		"A0RepairCentre3", // repair facility 3
		"A0RepairCentre2", // repair facility 2
		"A0RepairCentre", // repair facility 1
	];

	this.tankBodies = [ 
	[
	],
	];

	this.tankPropulsions = [
	[
	],
	];

	this.apWeapons = [
	[
	],
	];
	
	this.atWeapons = [
	[
	],
	];
	
	this.abWeapons = [
	[
	],
	],

	this.aaWeapons = [
	[
	],
	];
	
	this.apCyborgStats = [
	[
	],
	];

	this.atCyborgStats = [
	[
	],
	];
	
	this.vtolBodies = contingencyBodiesHeavy;

	this.vtolWeapons = [
		"Bomb-Earthquake",
		"Bomb-FuelAir",
		"Missile-VTOL-MdArt",
		"Bomb5-VTOL-Plasmite",
		"Bomb4-VTOL-HvyINC",
		"Missile-VTOL-AT",
		"Bomb2-VTOL-HvHE",
		"Rocket-VTOL-HvyA-T",
		"Rocket-VTOL-TopAttack",
		"Bomb3-VTOL-LtINC",
		"Rocket-VTOL-MRL",
		"Rocket-VTOL-LtA-T",
		"Bomb1-VTOL-LtHE",
		"Rocket-VTOL-Pod3",
		"Rocket-VTOL-Pod2",
		"Rocket-VTOL-Pod",
	];

	this.defenses = [
	[
		"Bunker3-Rocket-Seraph",
		"Empl2-Rocket-TopAtkInc",
		"Bunker2-Rocket-TopAttack",
		"Bunker-Rocket-MRL",
		"PillBox4",
		"GuardTower1",
	],
	[
		"GuardTower-ATMiss",
		"Bunker3-Rocket-AT3",
		"Tower2-Rocket-AT2",
		"PillBox6",
		"Bunker3-Rocket-Pod3Quad",
		"Bunker3-Rocket-Pod3Twin",
		"Bunker3-Rocket-Pod3",
		"GuardTower5",
		"Bunker2-Rocket-Pod2Quad",
		"Bunker2-Rocket-Pod2Twin",
		"Tower2-Rocket-Pod2",
		"Bunker-Rocket-PodQuad",
		"Bunker-Rocket-PodTwin",
		"Bunker-Rocket-Pod",
		"Bunker-Rocket-MRL",
		"PillBox4",
		"GuardTower1",
	],
	[
		"Super-MissileArrayPlas-Empl",
		"Super-MissileArray-Empl",
		"X-Super-Missile",
		"X-Super-Rocket",
		"Bunker3-Rocket-AT3",
		"Bunker3-Rocket-Pod3Quad",
		"Bunker3-Rocket-Pod3Twin",
		"Tower3-Rocket-Pod3",
		"Bunker2-Rocket-AT2",
		"Bunker2-Rocket-Pod2Quad",
		"Bunker2-Rocket-Pod2Twin",
		"Bunker2-Rocket-Pod2",
		"PillBox6",
		"Bunker-Rocket-PodQuad",
		"Bunker-Rocket-PodTwin",
		"GuardTower6",
		"Bunker-Rocket-MRL",
		"PillBox1",
		"GuardTower1",
	],
	];

	this.artillery = [
	[
		"Empl3-TBM-Earthquake",
		"Bunker2-HowitzerInc",
		"Emplacement-Howitzer-Incenediary",
		"Bunker2-Howitzer",
		"Emplacement-Howitzer105",
		"Emplacement-RotMor",
		"Bunker-MortarRot",
		"Bunker-MortarInc",
		"Emplacement-MortarPit-Incenediary",
		"Bunker-Mortar",
		"Emplacement-MortarPit01",
	],
	[
		"Empl3-TBM-FuelAir",
		"Emplacement-Howitzer-Incenediary",
		"Bunker2-HowitzerInc",
		"Emplacement-Howitzer105",
		"Bunker2-Howitzer",
		"Emplacement-MortarPit-Incenediary",
		"Bunker-MortarInc",
		"Emplacement-RotMor",
		"Bunker-MortarRot",
		"Emplacement-MortarPit01",
		"Bunker-Mortar",
	],
	[
		"Super-HowitzerPlas-Empl",
		"Super-Howitzer-Empl",
		"Super-MortarPlas-Empl",
		"Super-Mortar-Empl",
	],
	[
		"Super-HowitzerRamjet-Empl",
		"Super-Howitzer-Empl",
		"Super-MortarRamjet-Empl",
		"Super-Mortar-Empl",
	],
	[
		"Bunker3-Rocket-Archangel",
		"Bunker2-Rocket-Ripple",
	],
	[
		"Empl3-TBM-Plasmite",
		"Empl3-TBM-Earthquake",
		"Empl3-HowitzerRamjetHvy",
		"Bunker3-HowitzerRamjet",
		"Bunker2-Howitzer",
		"Bunker3-Mortar-RamjetRot",
		"Bunker3-Mortar-Ramjet",
		"Bunker-Mortar",
	],
	[
		"Empl3-TBM-Precision",
		"Empl3-TBM-FuelAir",
		"Bunker3-HowitzerRamjetRot",
		"Empl3-HowitzerRamjet",
		"Emplacement-Howitzer105",
		"Empl3-Mortar-RamjetHvy",
		"Empl3-Mortar-Ramjet",
		"Super-Mortar-Empl",
	],
	];
	
	this.defenses = this.defenses.concat(this.artillery);

	this.antiair = [
		"WallTower-SamHvy",
		"Bunker2-Rocket-SAM",
		"WallTower3-Rocket-Cherub",
		"Bunker-Rocket-Sunburst",
	];

	this.hardpoints = this.defenses;
	
	this.researchPathPrimary = [
		"R-Defense-Tower-MG1",
		"R-Defense-Bunker-MG1",
		"R-Defense-Bunker-Cannon-Lgt",
		"R-Defense-Tower-Rocket-Pod",
		"R-Defense-Bunker-Rocket-MRL",
	];

	this.researchPathFundamental = [
		"R-Sys-Sensor-Tower01",
		"R-Defense-Empl-Mortar",
		"R-Sys-CBSensor-Tower01",
		"R-Defense-Bunker-MortarInc",
		"R-Defense-Empl-MortarInc",
		"R-Sys-Sensor-Tower02",
		"R-Defense-Empl2-Rocket-TopAtkInc",
		"R-Defense-Bunker-Rocket-Sunburst",
		"R-Defense-Empl3-Mortar-Ramjet",
		"R-Defense-Bunker2-Rocket-Ripple",
		"R-Defense-Super-Rocket",
		"R-Defense-Super-Mortar",
		"R-Defense-Super-MortarPlas",
		"R-Vehicle-Body05",
		"R-Struc-VTOLPad",
		"R-Struc-VTOLFactory",
		"R-Wpn-Bomb03",
		"R-Defense-Empl2-HowitzerInc",
		"R-Vehicle-Body06",
		"R-Defense-Super-Missile",
		"R-Defense-Super-Howitzer",
		"R-Defense-Super-HowitzerPlas",
		"R-Sys-Sensor-WSTower",
		"R-Vehicle-Body21",
		"R-Defense-Super-MissileArrayPlas",
		"R-Struc-Power-Upgrade09",
		"R-Defense-Bunker3-Rocket-Archangel",
		"R-Sys-Sensor-UpLink",
		"R-Wpn-LasSat",
		"R-Vehicle-Body16",
		"R-Wpn-Bomb-Earthquake",
		"R-Defense-Empl3-TBM-FuelAir",
	];
	
	this.researchPathAT = [
		"R-Defense-Bunker-Cannon-Lgt",
		"R-Defense-Bunker-Rocket-Pod",
		"R-Defense-Tower-Rocket-Pod",
		"R-Defense-WallTower-Rocket-Pod",
		"R-Defense-Bunker-Rocket-PodTwin",
		"R-Defense-WallTower-Rocket-PodTwin",
		"R-Defense-Bunker-Rocket-PodQuad",
		"R-Defense-WallTower-Rocket-PodQuad",
		"R-Defense-Tower2-Rocket-Pod2",
		"R-Defense-Tower-Rocket-AT",
		"R-Defense-WallTower2-Rocket-Pod2",
		"R-Defense-WallTower2-Rocket-Pod2Twin",
		"R-Defense-WallTower2-Rocket-Pod2Quad",
		"R-Defense-Super-Rocket",
		"R-Defense-Empl3-Mortar-Ramjet",
		"R-Defense-Bunker3-Mortar-Ramjet",
		"R-Defense-Bunker2-Rocket-Pod2",
		"R-Defense-Bunker3-Mortar-RamjetRot",
		"R-Defense-Bunker2-Rocket-Pod2Twin",
		"R-Defense-Bunker2-Rocket-Pod2Quad",
		"R-Defense-Super-MortarRamjet",
		"R-Defense-WallTower-Rocket-AT",
		"R-Defense-Tower3-Rocket-Pod3",
		"R-Defense-WallTower3-Rocket-Pod3",
		"R-Defense-WallTower3-Rocket-Pod3Twin",
		"R-Defense-WallTower3-Rocket-Pod3Quad",
		"R-Defense-Empl3-Mortar-RamjetHvy",
		"R-Defense-Bunker-Rocket-AT",
		"R-Defense-Bunker3-Rocket-Pod3",
		"R-Defense-WallTower2-Rocket-AT2",
		"R-Defense-Super-Missile",
		"R-Defense-Bunker3-HowitzerRamjet",
		"R-Defense-Empl3-HowitzerRamjet",
		"R-Defense-Tower2-Rocket-AT2",
		"R-Defense-Bunker3-Rocket-Pod3Twin",
		"R-Defense-Super-HowitzerRamjet",
		"R-Defense-Bunker3-Rocket-Pod3Quad",
		"R-Defense-Bunker2-Rocket-AT2",
		"R-Defense-Bunker3-HowitzerRamjetRot",
		"R-Defense-WallTower3-Rocket-AT3",
		"R-Defense-Bunker3-Rocket-AT3",
		"R-Defense-Empl3-TBM-Precision",
		"R-Defense-Empl3-HowitzerRamjetHvy",
		
	];
	
	this.researchPathAP = [
		"R-Defense-Bunker-Rocket-MRL",
		"R-Defense-Bunker2-Rocket-TopAttack",
		"R-Defense-Bunker3-Rocket-Seraph",
		"R-Defense-Empl3-TBM-Plasmite",
	];
	
	this.researchPathAA = [
		"R-Defense-Bunker-Rocket-Sunburst",
		"R-Defense-WallTower3-Rocket-Cherub",
		"R-Defense-Bunker2-Rocket-SAM",
		"R-Defense-WallTower3-Rocket-SAM2",
	];
	
	this.researchPathAB = [
		"R-Defense-Bunker-Mortar",
		"R-Defense-Bunker2-Rocket-Ripple",
		"R-Wpn-Bomb03",
		"R-Struc-VTOLPad",
		"R-Struc-VTOLFactory",
		"R-Defense-Super-Mortar",
		"R-Defense-Bunker2-Howitzer",
		"R-Wpn-Bomb04",
		"R-Defense-Super-Howitzer",
		"R-Wpn-Bomb05",
		"R-Defense-Bunker2-HowitzerHvy",
		"R-Wpn-TBM-Earthquake",
		"R-Wpn-Bomb-FuelAir",
		"R-Defense-Bunker3-Rocket-Archangel",
		"R-Defense-Empl3-TBM-Earthquake",
	];
}

function buildOrder() {
	var labCount = enumStruct(me, lab).length;
	var factoryCount = enumStruct(me, factory).length;
	var commandCount = enumStruct(me, command).length;
	var genCount = enumStruct(me, generator).length;
	var derrickCount = enumStruct(me, derrick).length;
	var borgCount = enumStruct(me, borgfac).length;
	var vtolCount = enumStruct(me, vtolfac).length;
	if (genCount < 2 && playerPower(me) < EXTREME_LOW_POWER && isStructureAvailable(generator,me))
		return buildBasicStructure(generator);
	if (factoryCount < 1 && isStructureAvailable(factory,me))
		return buildBasicStructure(factory);
	if (labCount < 1 && isStructureAvailable(lab,me))
		return buildBasicStructure(lab);
	if (commandCount < 1 && isStructureAvailable(command,me))
		return buildBasicStructure(command);
	if (labCount < 2 && isStructureAvailable(lab,me))
		return buildBasicStructure(lab,0);
	if ((genCount < 2) && isStructureAvailable(generator,me))
		return buildBasicStructure(generator);
	if (labCount < 3 && isStructureAvailable(lab,me))
		return buildBasicStructure(lab,0);
	if (vtolCount < 1 && isStructureAvailable(vtolfac,me))
		return buildBasicStructure(vtolfac,0);
	return false;
}
