
	/********************************/
	/* Generic branch specific code */
	/********************************/

function constructPersonality() {

	this.MIN_BUILDERS = 2;		// the usual number of trucks that construct base structures
	this.MAX_BUILDERS = 3;		// the maximum number of trucks that construct base structures
	this.MIN_OILERS = 2;		// the usual number of trucks used for oil hunting
	this.MAX_OILERS = 3+random(2);		// the maximum number of trucks used for oil hunting
	this.MIN_DEFENDERS = 4;		// the minimum number of tanks before producing more trucks than necessary
	this.DEFENSIVENESS = 2;		// regulates chance of spending money on defensive structures
	this.PEACE_TIME = 10;		// the amount of minutes for free scouting (regrouping disabled, no defenses built)

	this.THIS_AI_MAKES_TANKS = true;
	this.THIS_AI_MAKES_CYBORGS = true;
	this.THIS_AI_MAKES_VTOLS = true;

	// override the global to make use of multiple different research facilities
	repair = [
		"A0RepairCentre4", // repair facility 4
		"A0RepairCentre3", // repair facility 3
		"A0RepairCentre2", // repair facility 2
		"A0RepairCentre", // repair facility 1
	];

	if (typeof(forcePersonality)=="undefined")
		this.subpersonality = random(3);
	else
		this.subpersonality = forcePersonality;

	this.researchPathFundamental = [
		"R-Vehicle-Body05",
		"R-Sys-Sensor-Tower01",
		"R-Struc-Research-Module",
		"R-Struc-Factory-Module",
		"R-Struc-RepairFacility2",
		"R-Vehicle-Body11",
		"R-Struc-Power-Upgrade01",
		"R-Sys-Sensor-Tower02",
		"R-Struc-Factory-Cyborg",
		"R-Vehicle-Prop-Tracks",
		"R-Sys-CBSensor-Tower01",
		"R-Vehicle-Body12",
		"R-Sys-Autorepair-General",
		"R-Struc-Power-Upgrade03",
		"R-Struc-VTOLPad",
		"R-Struc-VTOLFactory",
		"R-Struc-Power-Upgrade06",
		"R-Vehicle-Body09",
		"R-Vehicle-Body18",
		"R-Struc-RepairFacility3",
		"R-Sys-Sensor-WSTower",
		"R-Sys-Sensor-UpLink",
		"R-Vehicle-Body10",
		"R-Vehicle-Body22",
		"R-Struc-RepairFacility4",
		"R-Wpn-LasSat",
		"R-Struc-Research-Upgrade09",
		"R-Vehicle-Body14",
		"R-Struc-Power-Upgrade09",
	];
	
	this.abWeapons = [
	[
		"HowitzerGaussRot",
		"HowitzerGaussHvy",
		"HowitzerGauss",
		"Mortar-GaussRot",
		"Mortar-GaussHvy",
		"Mortar-Gauss",
		"Howitzer-Incenediary",
		"Mortar-Incenediary",
		"Howitzer03-Rot",
		"Howitzer150Mk1",
		"Howitzer105Mk1",
		"Mortar3ROTARYMk1",
		"Mortar2Mk1",
		"Mortar1Mk1",
	],
	[
		"HowitzerGaussRot",
		"HowitzerGaussHvy",
		"HowitzerGauss",
		"Howitzer-Incenediary",
		"Howitzer03-Rot",
		"Howitzer150Mk1",
		"Howitzer105Mk1",
		"Mortar-GaussRot",
		"Mortar-GaussHvy",
		"Mortar-Gauss",
		"Mortar-Incenediary",
		"Mortar3ROTARYMk1",
		"Mortar2Mk1",
		"Mortar1Mk1",
	],
	];

	switch (this.subpersonality) {
	case 0:

		this.tankBodies = [ contingencyBodiesLight, ];
		this.tankBodiesAP = [ contingencyBodiesHeavy, ];

		this.tankPropulsions = [
		[
			"tracked01", // tracks
			"HalfTrack", // half-track
			"wheeled01", // wheels
		],
		];

		this.apWeapons = [
		[
			"Laser-AP4",
			"Laser-AP3",
			"MG4IncTwin",
			"MG4Inc",
			"MG3IncTwin",
			"MG3Inc",
			"Laser-AP2",
			"MG5TWINROTARY",
			"MG4ROTARYMk1",
			"Laser-AP1",
			"MG3Twin",
			"MG3Mk1",
			"MG2Mk1",
			"MG1Mk1",
		],
		];

		this.atWeapons = [
		[
			"Laser-AT4",
			"Laser-AT3",
			"Laser-AT2",
			"MG-AntiTank2",
			"Laser-AT1",
			"MG-AntiTank",
			"Cannon1Mk1",
		],
		[
			"Laser-TankDest2",
			"Laser-TankDest",
			"MG4IncTwin",
			"MG4Inc",
			"MG3IncTwin",
			"MG3Inc",
		],
		];

		this.abWeapons = this.abWeapons.concat([
		[
			"Laser-Sonic-TankDest",
			"Laser-Sonic",
		],
		]);

		this.aaWeapons = [
		[
			"Laser-AA2",
			"Laser-AA",
			"MG-AA2",
			"MG-AA",
		],
		];

		this.apCyborgStats = [
		[
			["Cyb-Bod-Laser-AP3","Cyb-Wpn-Laser-AP3"],
			["Cyb-Bod-MG4Inc","Cyb-Wpn-MG4Inc"],
			["Cyb-Bod-Laser-AP1","Cyb-Wpn-Laser-AP1"],
			["Cyb-Bod-MG3Inc","Cyb-Wpn-MG3Inc"],
			["CybRotMgGrd","CyborgRotMG"],
			["CyborgChain1Ground","CyborgChaingun"],
		],
		[
			["HvyCyb-Bod-Laser-AP3","HvyCyb-Wpn-Laser-AP3"],
			["HvyCyb-Bod-MG4Inc","HvyCyb-Wpn-MG4Inc"],
			["HvyCyb-Bod-MG3Inc","HvyCyb-Wpn-MG3Inc"],
			["HvyCyb-Bod-Laser-AP1","HvyCyb-Wpn-Laser-AP1"],
			["HvyCyb-Bod-MG4","HvyCyb-Wpn-MG4"],
			["HvyCyb-Bod-MG3","HvyCyb-Wpn-MG3"],
		],
		];

		this.atCyborgStats = [
		[
			["HvyCyb-Bod-Laser-AT3","HvyCyb-Wpn-Laser-AT3"],
			["HvyCyb-Bod-MG-AntiTank2","HvyCyb-Wpn-MG-AntiTank2"],
			["HvyCyb-Bod-Laser-AT1","HvyCyb-Wpn-Laser-AT1"],
			["HvyCyb-Bod-MG-AntiTank","HvyCyb-Wpn-MG-AntiTank"],
			["CyborgCannonGrd","CyborgCannon"],
		],
		[
			["Cyb-Bod-Laser-AT3","Cyb-Wpn-Laser-AT3"],
			["Cyb-Bod-Laser-AT1","Cyb-Wpn-Laser-AT1"],
			["HvyCyb-Bod-MG-AntiTank2","HvyCyb-Wpn-MG-AntiTank2"],
			["HvyCyb-Bod-MG-AntiTank","HvyCyb-Wpn-MG-AntiTank"],
			["CyborgCannonGrd","CyborgCannon"],
		],
		];

		this.vtolBodies = contingencyBodiesLight;

		this.vtolWeapons = [
			"Bomb-Earthquake",
			"Bomb-FuelAir",
			"Bomb5-VTOL-Plasmite",
			"Bomb4-VTOL-HvyINC",
			"Bomb2-VTOL-HvHE",
			"Bomb3-VTOL-LtINC",
			"MG-AntiTank2-VTOL",
			"MG-AntiTank-VTOL",
			"Bomb1-VTOL-LtHE",
			"MG4Inc-VTOL",
			"MG3Inc-VTOL",
		];

		this.defenses = [
		[
			"Tower3-Laser-AP3",
			"Tower2-Laser-AP1",
			"Tower3-MG4Inc",
			"Tower-MG3Inc",
			"Tower-RotMg",
			"GuardTower3",
			"GuardTower2",
			"GuardTower1",
		],
		[
			"Bunker3-Laser-AP4",
			"Bunker3-Laser-AP3",
			"Bunker2-Laser-AP2",
			"Bunker2-Laser-AP1",
			"Bunker3-MG4IncTwin",
			"Bunker3-MG4Inc",
			"Bunker-MG3IncTwin",
			"Bunker-MG3Inc",
			"Bunker2-MG5",
			"Pillbox-RotMG",
			"Bunker-MG3Twin",
			"PillBox1",
		],
		[
			"Bunker3-Laser-AT4",
			"Bunker3-Laser-AT3",
			"Bunker2-Laser-AT2",
			"Bunker2-Laser-AT1",
			"Bunker2-MG-AntiTank2",
			"Bunker-MG-AntiTank",
		],
		[
			"Tower3-Laser-AT3",
			"Tower2-Laser-AT1",
			"Tower2-MG-AntiTank2",
			"Tower-MG-AntiTank",
		],
		[
			"Super-Laser2-Fort",
			"Super-Laser-Fort",
			"Super-MGPlas-Fort",
			"Super-MG-Fort",
		],
		];

		this.artillery = [
		[
			"Super-MortarGauss-Empl",
			"Super-Mortar-Empl",
			"Bunker2-Howitzer",
			"Bunker-Mortar",
		],
		[
			"Super-HowitzerGauss-Empl",
			"Super-Howitzer-Empl",
			"Emplacement-Howitzer105",
			"Emplacement-MortarPit01",
		],
		];


		this.antiair = [
			"Bunker3-Laser-AA2",
			"Bunker-Laser-AA",
			"Bunker2-MG-AA2",
			"Bunker-MG-AA",
		];

		this.hardpoints = [
		[
			"WallTower3-Laser-AP4",
			"WallTower3-Laser-AP3",
			"WallTower2-Laser-AP2",
			"WallTower2-Laser-AP1",
			"WallTower3-MG4IncTwin",
			"WallTower3-MG4Inc",
			"WallTower-MG3IncTwin",
			"WallTower-MG3Inc",
			"WallTower-TwinAssaultGun",
			"Wall-RotMg",
			"WallTower-MG3Twin",
			"WallTower01",
		],
		[
			"WallTower3-Laser-AT4",
			"WallTower3-Laser-AT3",
			"WallTower2-Laser-AT2",
			"WallTower2-Laser-AT1",
			"WallTower2-MG-AntiTank2",
			"WallTower-MG-AntiTank",
			"WallTower3-MG4IncTwin",
			"WallTower3-MG4Inc",
			"WallTower-MG3IncTwin",
			"WallTower-MG3Inc",
		],
		];
		
		this.researchPathPrimary = [
			"R-Wpn-Cannon-Damage01",
			"R-Vehicle-Prop-Halftracks",
			"R-Wpn-MG2Mk1",
			"R-Struc-PowerModuleMk1",
			"R-Struc-Factory-Cyborg",
			"R-Vehicle-Body04",
		];

		this.researchPathAT = [
			"R-Defense-Bunker-MG-AntiTank",
			"R-Defense-Tower-MG-AntiTank",
			"R-Defense-WallTower-MG-AntiTank",
			"R-Defense-Bunker2-MG-AntiTank2",
			"R-Defense-Tower2-MG-AntiTank2",
			"R-Defense-WallTower2-MG-AntiTank2",
			"R-Defense-Super-Machinegun",
			"R-Defense-Bunker2-Laser-AT1",
			"R-Defense-Tower2-Laser-AT1",
			"R-Defense-WallTower2-Laser-AT1",
			"R-Defense-Bunker2-Laser-AT2",
			"R-Defense-WallTower2-Laser-AT2",
			"R-Defense-Bunker3-Laser-AT3",
			"R-Defense-Tower3-Laser-AT3",
			"R-Defense-WallTower3-Laser-AT3",
			"R-Defense-Bunker3-Laser-AT4",
			"R-Defense-WallTower3-Laser-AT4",
			"R-Defense-Super-Laser",
		];
		
		this.researchPathAP = [
			"R-Defense-Tower-MG1",
			"R-Defense-Bunker-MG1",
			"R-Defense-Tower-MG2",
			"R-Defense-Bunker-MG2",
			"R-Defense-Tower-MG3",
			"R-Defense-Bunker-MG3",
			"R-Defense-WallTower-MG3",
			"R-Defense-WallTower-MG3Twin",
			"R-Defense-Tower2-MG4",
			"R-Defense-Bunker2-MG4",
			"R-Defense-WallTower2-MG4",
			"R-Defense-Super-Machinegun",
			"R-Defense-WallTower2-MG5",
			"R-Defense-Bunker2-MG5",
			"R-Defense-Bunker-MG3Inc",
			"R-Defense-WallTower-MG3Inc",
			"R-Defense-Bunker-MG3IncTwin",
			"R-Defense-WallTower-MG3IncTwin",
			"R-Defense-Bunker3-MG4Inc",
			"R-Defense-WallTower3-MG4Inc",
			"R-Defense-Bunker3-MG4IncTwin",
			"R-Defense-WallTower3-MG4IncTwin",
			"R-Defense-Super-MachinegunPlas",
			"R-Defense-Bunker2-Laser-AP1",
			"R-Defense-Tower2-Laser-AP1",
			"R-Defense-WallTower2-Laser-AP1",
			"R-Defense-Bunker2-Laser-AP2",
			"R-Defense-WallTower2-Laser-AP2",
			"R-Defense-Bunker3-Laser-AP3",
			"R-Defense-Tower3-Laser-AP3",
			"R-Defense-WallTower3-Laser-AP3",
			"R-Defense-Bunker3-Laser-AP4",
			"R-Defense-WallTower3-Laser-AP4",
			"R-Defense-Super-Laser",
		];
		
		this.researchPathAA = [
			"R-Defense-Bunker-MG-AA",
			"R-Defense-Bunker2-MG-AA2",
			"R-Defense-Bunker-Laser-AA",
			"R-Defense-Bunker3-Laser-AA2",
		];
		
		this.researchPathAB = [
			"R-Defense-Bunker-Mortar",
			"R-Defense-Bunker2-Howitzer",
			"R-Defense-Bunker2-HowitzerHvy",
			"R-Defense-Super-Mortar",
			"R-Defense-Super-Howitzer",
			"R-Defense-Super-MortarGauss",
			"R-Defense-Super-HowitzerGauss",
			"R-Wpn-Laser-Sonic-TankDest",
		];

	break;
	case 1:

		this.tankBodies = [ contingencyBodiesLight, ];

		this.tankPropulsions = [
		[
			"hover01", // hovers
			"HalfTrack", // half-track
			"wheeled01", // wheels
		],
		];

		this.apWeapons = [
		[
			"Laser-AP4",
			"Laser-AP3",
			"Laser-AP2",
			"Laser-AP1",
			"PlasmiteFlamer",
			"Flame2",
			"Flame1Mk1",
			"MG1Mk1",
		],
		[
			"Flamer-PlasmaCannon",
			"PlasmiteFlamer",
			"Flame2",
			"Flame1Mk1",
			"Cannon1Mk1",
			"MG1Mk1",
		],
		];
		
		this.atWeapons = [
		[
			"Laser-AT4",
			"Laser-AT3",
			"Laser-AT2",
			"Laser-AT1",
			"PlasmiteFlamer",
			"Flame2",
			"Cannon1Mk1",
			"Flame1Mk1",
			"MG1Mk1",
		],
		[
			"Laser-TankDest2",
			"Laser-TankDest",
			"PlasmiteFlamer",
			"Flame2",
			"Flame1Mk1",
			"Cannon1Mk1",
			"MG1Mk1",
		],
		[
			"Flamer-PlasCan-TankDest",
			"PlasmiteFlamer",
			"Flame2",
			"Flame1Mk1",
			"Cannon1Mk1",
			"MG1Mk1",
		],
		];

		this.abWeapons = this.abWeapons.concat([
		[
			"Laser-Sonic-TankDest",
			"Laser-Sonic",
		],
		]);
		
		this.aaWeapons = [
		[
			"Laser-AA2",
			"Laser-AA",
			"MG-AA2",
			"MG-AA",
		],
		];
		
		this.apCyborgStats = [
		[
			["Cyb-Bod-Laser-AP3","Cyb-Wpn-Laser-AP3"],
			["Cyb-Bod-MG4Inc","Cyb-Wpn-MG4Inc"],
			["Cyb-Bod-Laser-AP1","Cyb-Wpn-Laser-AP1"],
			["Cyb-Bod-MG3Inc","Cyb-Wpn-MG3Inc"],
			["Cyb-Bod-Thermite","Cyb-Wpn-Thermite"],
			["CyborgFlamerGrd","CyborgFlamer01"],
			["CyborgChain1Ground","CyborgChaingun"],
		],
		[
			["HvyCyb-Bod-Laser-AP3","HvyCyb-Wpn-Laser-AP3"],
			["HvyCyb-Bod-Flamer3","HvyCyb-Wpn-Flamer3"],
			["HvyCyb-Bod-Laser-AP1","HvyCyb-Wpn-Laser-AP1"],
			["HvyCyb-Bod-Flamer2","HvyCyb-Wpn-Flamer2"],
			["HvyCyb-Bod-Flamer1","HvyCyb-Wpn-Flamer1"],
			["CyborgChain1Ground","CyborgChaingun"],
		],
		[
			["Cyb-Bod-Laser-AP3","Cyb-Wpn-Laser-AP3"],
			["HvyCyb-Bod-Laser-AP1","HvyCyb-Wpn-Laser-AP1"],
			["Cyb-Bod-MortarInc","Cyb-Wpn-MortarInc"],
			["Cyb-Bod-Thermite","Cyb-Wpn-Thermite"],
			["CyborgFlamerGrd","CyborgFlamer01"],
			["CyborgCannonGrd","CyborgCannon"],
		],
		];

		this.atCyborgStats = [
		[
			["HvyCyb-Bod-Laser-AT3","HvyCyb-Wpn-Laser-AT3"],
			["HvyCyb-Bod-Laser-AT1","HvyCyb-Wpn-Laser-AT1"],
			["HvyCyb-Bod-Flamer3","HvyCyb-Wpn-Flamer3"],
			["HvyCyb-Bod-Flamer2","HvyCyb-Wpn-Flamer2"],
			["HvyCyb-Bod-Flamer1","HvyCyb-Wpn-Flamer1"],
			["CyborgCannonGrd","CyborgCannon"],
		],
		[
			["Cyb-Bod-Laser-AT3","Cyb-Wpn-Laser-AT3"],
			["Cyb-Bod-Thermite","Cyb-Wpn-Thermite"],
			["Cyb-Bod-Laser-AT1","Cyb-Wpn-Laser-AT1"],
			["CyborgFlamerGrd","CyborgFlamer01"],
			["CyborgCannonGrd","CyborgCannon"],
		],
		[
			["HvyCyb-Bod-Laser-AT3","HvyCyb-Wpn-Laser-AT3"],
			["Cyb-Bod-MortarInc","Cyb-Wpn-MortarInc"],
			["Cyb-Bod-Thermite","Cyb-Wpn-Thermite"],
			["Cyb-Bod-Laser-AT1","Cyb-Wpn-Laser-AT1"],
			["CyborgFlamerGrd","CyborgFlamer01"],
			["CyborgCannonGrd","CyborgCannon"],
		],
		];
		
		this.vtolBodies = contingencyBodiesLight;

		this.vtolWeapons = [
			"Bomb-Earthquake",
			"Bomb-FuelAir",
			"Bomb5-VTOL-Plasmite",
			"Bomb4-VTOL-HvyINC",
			"Bomb2-VTOL-HvHE",
			"Bomb3-VTOL-LtINC",
			"Bomb1-VTOL-LtHE",
		];

		this.defenses = [
		[
			"Tower3-Laser-AP3",
			"Tower2-Laser-AP1",
		],
		[
			"Bunker3-Laser-AP4",
			"Bunker3-Laser-AP3",
			"Bunker2-Laser-AP2",
			"Bunker2-Laser-AP1",
		],
		[
			"Bunker3-Laser-AT4",
			"Bunker3-Laser-AT3",
			"Bunker2-Laser-AT2",
			"Bunker2-Laser-AT1",
		],
		[
			"Tower3-Laser-AT3",
			"Tower2-Laser-AT1",
		],
		[
			"Super-Laser2-Fort",
			"Super-Laser-Fort",
		],
		];

		this.artillery = [
		[
			"Bunker2-HowitzerInc",
			"Bunker2-Howitzer",
			"Bunker-MortarInc",
			"Bunker-Mortar",
		],
		[
			"Emplacement-Howitzer-Incenediary",
			"Emplacement-Howitzer105",
			"Emplacement-MortarPit-Incenediary",
			"Emplacement-MortarPit01",
		],
		[
			"Super-HowitzerPlas-Empl",
			"Super-Howitzer-Empl",
			"Super-MortarPlas-Empl",
			"Super-Mortar-Empl",
		],
		];

		this.antiair = [
			"WallTower3-Laser-AA2",
			"WallTower-Laser-AA",
			"WallTower2-MG-AA2",
			"WallTower-MG-AA",
		];

		this.hardpoints = [
		[
			"WallTower3-Laser-AP4",
			"WallTower3-Laser-AP3",
			"WallTower2-Laser-AP2",
			"WallTower2-Laser-AP1",
		],
		[
			"WallTower3-Laser-AT4",
			"WallTower3-Laser-AT3",
			"WallTower2-Laser-AT2",
			"WallTower2-Laser-AT1",
		],
		];
		
		this.researchPathPrimary = [
			"R-Wpn-Cannon-Damage01",
			"R-Vehicle-Prop-Halftracks",
			"R-Wpn-Flamer-ROF01",
			"R-Struc-PowerModuleMk1",
			"R-Struc-Factory-Cyborg",
			"R-Vehicle-Body04",
			"R-Vehicle-Prop-Halftracks",
			"R-Wpn-Flame2",
			"R-Defense-Empl-MortarInc",
			"R-Struc-Research-Upgrade05",
			"R-Struc-PowerModuleMk1",
			"R-Wpn-Plasmite-Flamer",
		];
		
		this.researchPathAT = [
			"R-Wpn-Flamer-PlasCan-TankDest",
			"R-Defense-Bunker2-Laser-AT1",
			"R-Defense-Tower2-Laser-AT1",
			"R-Defense-WallTower2-Laser-AT1",
			"R-Defense-Bunker2-Laser-AT2",
			"R-Defense-WallTower2-Laser-AT2",
			"R-Defense-Bunker3-Laser-AT3",
			"R-Defense-Tower3-Laser-AT3",
			"R-Defense-WallTower3-Laser-AT3",
			"R-Defense-Bunker3-Laser-AT4",
			"R-Defense-WallTower3-Laser-AT4",
			"R-Defense-Super-Laser",
		];
		
		this.researchPathAP = [
			"R-Wpn-Flamer-PlasmaCannon",
			"R-Defense-Bunker2-Laser-AP1",
			"R-Defense-Tower2-Laser-AP1",
			"R-Defense-WallTower2-Laser-AP1",
			"R-Defense-Bunker2-Laser-AP2",
			"R-Defense-WallTower2-Laser-AP2",
			"R-Defense-Bunker3-Laser-AP3",
			"R-Defense-Tower3-Laser-AP3",
			"R-Defense-WallTower3-Laser-AP3",
			"R-Defense-Bunker3-Laser-AP4",
			"R-Defense-WallTower3-Laser-AP4",
			"R-Defense-Super-Laser",
		];
		
		this.researchPathAA = [
			"R-Defense-WallTower-MG-AA",
			"R-Defense-WallTower2-MG-AA2",
			"R-Defense-WallTower-Laser-AA",
			"R-Defense-WallTower3-Laser-AA2",
		];
		
		this.researchPathAB = [
			"R-Defense-Empl-MortarInc",
			"R-Defense-Super-MortarPlas",
			"R-Defense-Empl2-HowitzerInc",
			"R-Defense-Super-HowitzerPlas",
			"R-Wpn-Bomb-Earthquake",
			"R-Wpn-Laser-Sonic-TankDest",
		];

	break;
	case 2:

		this.tankBodies = [ contingencyBodiesLight, ];

		this.tankPropulsions = [
		[
			"tracked01", // tracks
			"HalfTrack", // half-track
			"wheeled01", // wheels
		],
		];

		this.atWeapons = [
		[
			"Railgun-GattlingAT",
			"Railgun-TankDest",
			"Railgun-Aslt",
			"Railgun-ProtoTankDest",
			"Railgun-Proto",
			"Cannon-HPVGattling",
			"Cannon-HPVHvy",
			"Cannon-HPVTwinAslt",
			"Cannon-HPVTankDest",
			"Cannon-HPVAslt",
			"Cannon-TankDest",
			"Cannon4AUTOMk1",
			"Cannon-HPVLgt",
			"Cannon2A-TMk1",
			"Cannon1Mk1",
		],
		];
		
		this.apWeapons = [
		[
			"Railgun-GattlingTwin",
			"Railgun-Shotgun",
			"Railgun-Gattling",
			"Railgun-TwinAslt",
			"Railgun-Proto",
			"Cannon-Shotgun",
			"Cannon-Gattling",
			"Cannon6TwinAslt",
			"Cannon375mmMk1",
			"Cannon5VulcanMk1",
			"Cannon2A-TMk1",
			"Cannon1Mk1",
		],
		[
			"SpyTurret03",
			"SpyTurret02",
			"SpyTurret01",
		],
		];
		
		// this.abWeapons already defined above.
		
		this.aaWeapons = [
		[
			"Railgun-GattlingAA",
			"Railgun-Flak",
			"AAGun2Mk1",
		],
		];
		
		this.atCyborgStats = [
		[
			["Cyb-Bod-Rail1","Cyb-Wpn-Rail1"],
			["Cyb-Hvybod-RailGunner","Cyb-Hvywpn-RailGunner"],
			["HvyCyb-Bod-Cannon-HPVAslt","HvyCyb-Wpn-Cannon-HPVAslt"],
			["Cyb-Hvybod-HPV","Cyb-Hvywpn-HPV"],
			["Cyb-Hvybod-Mcannon","Cyb-Hvywpn-Mcannon"],
			["CyborgCannonGrd","CyborgCannon"],
		],
		[
			["HvyCyb-Bod-Railgun-Aslt","HvyCyb-Wpn-Railgun-Aslt"],
			["Cyb-Bod-Rail1","Cyb-Wpn-Rail1"],
			["HvyCyb-Bod-Railgun-Gattling","HvyCyb-Bod-Railgun-GattlingInc"],
			["Cyb-Bod-Cannon-HPVLgt","Cyb-Wpn-Cannon-HPVLgt"],
			["CyborgCannonGrd","CyborgCannon"],
		],
		];
		
		this.apCyborgStats = [
		[
			["Cyb-Bod-Railgun-Sniper","Cyb-Wpn-Railgun-Sniper"],
			["HvyCyb-Bod-Cannon-Shotgun","HvyCyb-Wpn-Cannon-Shotgun"],
			["HvyCyb-Bod-MortarRot","HvyCyb-Wpn-MortarRot"],
			["Cyb-Bod-Cannon-Sniper","Cyb-Wpn-Cannon-Sniper"],
			["Cyb-Bod-Grenade","Cyb-Wpn-Grenade"],
			["Cyb-Hvybod-Acannon","Cyb-Hvywpn-Acannon"],
			["CyborgCannonGrd","CyborgCannon"],
		],
		[
			["HvyCyb-Bod-Railgun-Shotgun","HvyCyb-Wpn-Railgun-Shotgun"],
			["HvyCyb-Bod-Cannon-Shotgun","HvyCyb-Wpn-Cannon-Shotgun"],
			["HvyCyb-Bod-MortarRot","HvyCyb-Wpn-MortarRot"],
			["Cyb-Bod-Grenade","Cyb-Wpn-Grenade"],
			["CyborgCannonGrd","CyborgCannon"],
		],
		];

		this.vtolBodies = contingencyBodiesLight;

		this.vtolWeapons = [
			"Bomb-Earthquake",
			"Railgun-GattlingInc-VTOL",
			"Railgun-Gattling-VTOL",
			"Railgun-Aslt-VTOL",
			"Bomb-FuelAir",
			"Bomb5-VTOL-Plasmite",
			"Railgun-Shotgun-VTOL",
			"Bomb4-VTOL-HvyINC",
			"Cannon-HPVAslt-VTOL",
			"Cannon5Vulcan-VTOL",
			"Bomb2-VTOL-HvHE",
			"Cannon4AUTO-VTOL",
			"Cannon-HPVLgt-VTOL",
			"Cannon-Med-VTOL",
			"Bomb3-VTOL-LtINC",
			"Bomb1-VTOL-LtHE",
			"Cannon-Shotgun-VTOL",
			"Cannon1-VTOL",
		];

		this.defenses = [
		[
			"Bunker3-Railgun-TwinAslt",
			"Bunker3-Railgun-Hvy",
			"Bunker3-Railgun-Aslt",
			"Bunker3-Railgun-Med",
			"Bunker2-Cannon-Gattling",
			"Bunker3-Railgun-Lgt",
			"PillBox-Cannon6",
			"Bunker2-Railgun-Proto",
			"Bunker-Cannon-Hvy",
			"Bunker-Railgun-Proto",
			"Bunker-Cannon-Aslt",
			"Bunker-Cannon-Med",
			"PillBox4",
		],
		[
			"Bunker4-Railgun-GattlingAT",
			"Bunker3-Cannon-HPVGattling",
			"Bunker3-Cannon-Ramjet",
			"Bunker2-Cannon-HPVTwinAslt",
			"Bunker2-Cannon-HPVAslt",
			"Bunker2-Cannon-HPVHvy",
			"Bunker2-Cannon-HPVMed",
			"Bunker2-Cannon-HPVLgt",
		],
		[
			"Bunker4-Railgun-GattlingInc",
			"Bunker4-Railgun-Gattling",
			"Bunker3-Railgun-GattlingIncTwin",
			"Bunker3-Railgun-GattlingTwin",
			"Bunker3-Railgun-GattlingInc",
			"Bunker3-Railgun-Gattling",
			"Bunker3-Railgun-Shotgun",
			"Bunker4-Flamer-PlasmaCannon",
			"Bunker2-Cannon-Shotgun",
			"Bunker2-Cannon-Inc",
		],
		[
			"Tower-Cannon-Aslt",
			"Tower-Cannon-Med",
			"Tower-Cannon-Lgt",
		],
		[
			"Tower3-Railgun-Aslt",
			"Tower3-Railgun-Med",
			"GuardTower-Rail1",
			"Tower2-Cannon-HPVAslt",
			"Tower-VulcanCan",
			"Tower2-Cannon-HPVLgt",
		],
		[
			"Tower3-Railgun-GattlingIncTwin",
			"Tower3-Railgun-GattlingTwin",
			"Tower4-Railgun-GattlingInc",
			"Tower3-Railgun-GattlingInc",
			"Tower3-Railgun-Shotgun",
			"Tower4-Railgun-Gattling",
			"Tower3-Railgun-Gattling",
			"Tower2-Cannon-Shotgun",
		],
		[
			"Super-RailgunGattlingPlas-Fort2",
			"Super-RailgunGattling-Fort2",
			"Super-RailgunGattlingPlas-Fort",
			"Super-Railgun-Fort",
			"Super-PlasCannon-Fort",
			"Super-RailgunGattling-Fort",
			"Super-RotCannon-Fort",
			"X-Super-Cannon",
		],
		];

		this.artillery = [
		[
			"Super-MortarGauss-Empl",
			"Bunker4-HowitzerGauss",
			"Super-Mortar-Empl",
			"Bunker2-Howitzer",
			"Bunker-Mortar",
		],
		[
			"Super-HowitzerGauss-Empl",
			"Bunker4-HowitzerGaussHvy",
			"Super-Howitzer-Empl",
			"Bunker2-HowitzerHvy",
			"Emplacement-Howitzer105",
			"Emplacement-MortarPit01",
		],
		[
			"Bunker4-HowitzerGaussHvy",
			"Bunker2-HowitzerHvy",
			"Emplacement-Howitzer105",
			"Emplacement-MortarPit01",
		],
		];


		this.antiair = [
			"WallTower4-Railgun-GattlingAA",
			"Bunker4-Railgun-GattlingAA",
			"Empl4-Railgun-GattlingAA",
			"Bunker3-Railgun-GattlingAA",
			"WallTower3-Railgun-GattlingAA",
			"WallTower3-Railgun-Flak",
			"Bunker3-Railgun-Flak",
			"Empl3-Railgun-Flak",
			"WallTower-DoubleAAGun",
			"Bunker-Cannon-Flak",
			"AASite-QuadBof",
		];

		this.hardpoints = [
		[
			"WallTower3-Railgun-TwinAslt",
			"WallTower3-Railgun-Aslt",
			"WallTower-Rail3",
			"WallTower-Rail2",
 			"WallTower3-Railgun-Lgt",
			"WallTower2-Railgun-Proto",
			"WallTower-Railgun-Proto",
			"WallTower2-Cannon-Gattling",
			"WallTower-Cannon-TwinAslt",
			"Wall-VulcanCan",
			"WallTower04",
			"WallTower03",
			"WallTower02",
		],
		[
			"WallTower4-Railgun-GattlingAT",
			"WallTower2-Railgun-Proto",
			"WallTower3-Cannon-Ramjet",
			"WallTower3-Cannon-HPVGattling",
			"WallTower2-Cannon-HPVTwinAslt",
			"WallTower2-Cannon-HPVHvy",
			"WallTower2-Cannon-HPVAslt",
			"WallTower-HPVcannon",
			"WallTower2-Cannon-HPVLgt",
		],
		[
			"WallTower3-Railgun-GattlingIncTwin",
			"WallTower3-Railgun-GattlingTwin",
			"WallTower4-Railgun-GattlingInc",
			"WallTower3-Railgun-GattlingInc",
			"WallTower3-Railgun-Shotgun",
			"WallTower4-Railgun-Gattling",
			"WallTower3-Railgun-Gattling",
			"WallTower4-Flamer-PlasmaCannon",
			"WallTower3-Cannon-Plas",
			"WallTower2-Cannon-Shotgun",
			"WallTower2-Cannon-Inc",
		],
		];
		
		this.researchPathPrimary = [
			"R-Wpn-Cannon-Damage01",
			"R-Vehicle-Prop-Halftracks",
			"R-Vehicle-Body04",
			"R-Struc-PowerModuleMk1",
			"R-Struc-Factory-Cyborg",
			
		];

		this.researchPathAT = [
			"R-Defense-Bunker2-Cannon-HPVLgt",
			"R-Defense-Tower2-Cannon-HPVLgt",
			"R-Defense-WallTower2-Cannon-HPVLgt",
			"R-Defense-Bunker2-Cannon-HPVMed",
			"R-Defense-WallTower2-Cannon-HPVMed",
			"R-Defense-Tower2-Cannon-HPVMed",
			"R-Defense-Bunker2-Cannon-HPVHvy",
			"R-Defense-Tower2-Cannon-HPVAslt",
			"R-Defense-WallTower2-Cannon-HPVAslt",
			"R-Defense-Bunker2-Cannon-HPVAslt",
			"R-Defense-Bunker2-Cannon-HPVTwinAslt",
			"R-Defense-Bunker3-Cannon-HPVGattling",
			"R-Defense-WallTower2-Cannon-HPVTwinAslt",
			"R-Defense-WallTower2-Cannon-HPVHvy",
			"R-Defense-WallTower3-Cannon-HPVGattling",
			"R-Defense-Super-Cannon",
			"R-Defense-Super-RotCannon",
			"R-Defense-WallTower4-Railgun-GattlingAT",
			"R-Defense-Bunker4-Railgun-GattlingAT",
			"R-Defense-WallTower-Railgun-Proto",
			"R-Defense-WallTower2-Railgun-Proto",
			"R-Defense-WallTower3-Railgun-Lgt",
			"R-Defense-WallTower3-Railgun-Med",
			"R-Defense-WallTower3-Railgun-Hvy",
			"R-Defense-WallTower3-Railgun-Aslt",
			"R-Defense-WallTower3-Railgun-TwinAslt",
			"R-Defense-Tower3-Railgun-Gattling",
			"R-Defense-WallTower3-Railgun-Gattling",
			"R-Defense-Tower3-Railgun-GattlingTwin",
			"R-Defense-WallTower3-Railgun-GattlingTwin",
			"R-Defense-Tower4-Railgun-Gattling",
			"R-Defense-WallTower4-Railgun-Gattling",
			"R-Defense-Super-RailgunGattling",
			"R-Defense-Super-RailgunGattling2",
			"R-Defense-Super-RotRailgun",
		];
		
		this.researchPathAP = [
			"R-Sys-SpyTurret",
			"R-Defense-Bunker2-Cannon-Shotgun",
			"R-Defense-WallTower2-Cannon-Shotgun",
			"R-Defense-WallTower-Cannon-Lgt",
			"R-Defense-WallTower-Cannon-Med",
			"R-Defense-WallTower-Cannon-Hvy",
			"R-Defense-Bunker-Cannon-Lgt",
			"R-Defense-Tower-Cannon-Lgt",
			"R-Defense-Bunker-Cannon-Med",
			"R-Defense-Tower-Cannon-Med",
			"R-Defense-Tower-Cannon-Aslt",
			"R-Defense-WallTower-Cannon-Aslt",
			"R-Defense-WallTower-Cannon-TwinAslt",
			"R-Defense-Bunker-Cannon-Aslt",
			"R-Defense-Bunker-Cannon-Hvy",
			"R-Defense-Bunker-Cannon-TwinAslt",
			"R-Defense-Bunker2-Cannon-Gattling",
			"R-Defense-WallTower2-Cannon-Gattling",
			"R-Sys-SpyTurret02",
			"R-Defense-Super-Cannon",
			"R-Defense-Super-RotCannon",
			"R-Defense-Bunker3-Railgun-Gattling",
			"R-Defense-Bunker3-Railgun-GattlingTwin",
			"R-Defense-Bunker-Railgun-Proto",
			"R-Defense-Bunker2-Railgun-Proto",
			"R-Defense-Bunker3-Railgun-Lgt",
			"R-Defense-Bunker3-Railgun-Med",
			"R-Defense-Bunker3-Railgun-Hvy",
			"R-Defense-Bunker3-Railgun-Aslt",
			"R-Defense-Bunker3-Railgun-TwinAslt",
			"R-Defense-Bunker3-Railgun-Shotgun",
			"R-Sys-SpyTurret03",
			"R-Defense-Super-RailgunGattling",
			"R-Defense-Super-RailgunGattling2",
			"R-Defense-Super-RotRailgun",
		];
		
		this.researchPathAA = [
			"R-Defense-Bunker-Cannon-Flak",
			"R-Defense-Bunker3-Railgun-Flak",
			"R-Defense-Bunker3-Railgun-GattlingAA",
			"R-Defense-Bunker4-Railgun-GattlingAA",
		];
		
		this.researchPathAB = [
			"R-Defense-Bunker-Mortar",
			"R-Defense-Super-Mortar",
			"R-Defense-Bunker2-Howitzer",
			"R-Defense-Super-Howitzer",
			"R-Defense-Bunker2-HowitzerHvy",
			"R-Defense-Bunker4-HowitzerGaussHvy",
			"R-Defense-Super-MortarGauss",
			"R-Defense-Super-HowitzerGauss",
			"R-Wpn-Bomb-Earthquake",
		];
	
	break;
	case 3:

		this.tankBodies = [ contingencyBodiesLight, contingencyBodiesHeavy, ];

		this.tankPropulsions = [
		[
			"tracked01", // tracks
			"HalfTrack", // half-track
			"wheeled01", // wheels
		],
		];

		this.apWeapons = [
		[
			"Missile-MdArt",
			"Rocket-TopAttack",
			"Rocket-MRL",
			"SpyTurret01",
			"Rocket-Pod",
			"MG1Mk1",
		],
		];

		this.atWeapons = [
		[
			"Missile-A-T",
			"Rocket-HvyA-T",
			"Rocket-LtA-T",
			"Rocket-Pod3Quad",
			"Rocket-Pod3Twin",
			"Rocket-Pod3",
			"Rocket-Pod2Quad",
			"Rocket-Pod2Twin",
			"Rocket-Pod2",
			"Rocket-PodQuad",
			"Rocket-PodTwin",
			"Rocket-Pod",
			"Cannon1Mk1",
		],
		];

		this.abWeapons = [
		[
			"Missile-HvyArt",
			"Rocket-BB2",
			"Missile-MdArt",
			"Rocket-IDF",
			"Rocket-TopAttack",
			"Rocket-BB",
			"Rocket-MRL",
		],
		[
			"Rocket-BB2",
			"Missile-HvyArt",
			"Missile-MdArt",
			"Rocket-BB",
			"Rocket-IDF",
			"Rocket-TopAttack",
			"Rocket-MRL",
		],
		];

		this.aaWeapons = [
		[
			"Missile-HvySAM",
			"Missile-LtSAM",
			"Rocket-Cherub",
			"Rocket-Sunburst",
		],
		];

		this.apCyborgStats = [
		[
			["HvyCyb-Bod-Missile-MdArt","HvyCyb-Wpn-Missile-MdArt"],
			["HvyCyb-Bod-Rocket-TopAttack","HvyCyb-Wpn-Rocket-TopAttack"],
			["HvyCyb-Bod-Rocket-MRL","HvyCyb-Wpn-Rocket-MRL"],
			["CyborgChain1Ground","CyborgChaingun"],
		],
		];

		this.atCyborgStats = [
		[
			["Cyb-Hvybod-A-T","Cyb-Hvywpn-A-T"],
			["Cyb-Hvybod-TK","Cyb-Hvywpn-TK"],
			["HvyCyb-Bod-Rocket-LtA-T","HvyCyb-Wpn-Rocket-LtA-T"],
			["HvyCyb-Bod-Rocket-Pod3","HvyCyb-Wpn-Rocket-Pod3"],
			["HvyCyb-Bod-Rocket-Pod2","HvyCyb-Wpn-Rocket-Pod2"],
			["HvyCyb-Bod-Rocket-Pod","HvyCyb-Wpn-Rocket-Pod"],
		],
		[
			["Cyb-Bod-Atmiss","Cyb-Wpn-Atmiss"],
			["Cyb-Bod-Rocket-HvyA-T","Cyb-Wpn-Rocket-HvyA-T"],
			["CyborgRkt1Ground","CyborgRocket"],
			["HvyCyb-Bod-Rocket-Pod3","HvyCyb-Wpn-Rocket-Pod3"],
			["HvyCyb-Bod-Rocket-Pod2","HvyCyb-Wpn-Rocket-Pod2"],
			["HvyCyb-Bod-Rocket-Pod","HvyCyb-Wpn-Rocket-Pod"],
			["CyborgCannonGrd","CyborgCannon"],
		],
		];

		this.vtolBodies = contingencyBodiesLight;

		this.vtolWeapons = [
			"Bomb-Earthquake",
			"Bomb-FuelAir",
			"Missile-VTOL-MdArt",
			"Bomb5-VTOL-Plasmite",
			"Bomb4-VTOL-HvyINC",
			"Missile-VTOL-AT",
			"Bomb2-VTOL-HvHE",
			"Rocket-VTOL-HvyA-T",
			"Rocket-VTOL-TopAttack",
			"Bomb3-VTOL-LtINC",
			"Rocket-VTOL-MRL",
			"Rocket-VTOL-LtA-T",
			"Bomb1-VTOL-LtHE",
			"Rocket-VTOL-Pod3",
			"Rocket-VTOL-Pod2",
			"Rocket-VTOL-Pod",
		];
		

		this.defenses = [
		[
			"Bunker3-Rocket-Seraph",
			"Bunker2-Rocket-TopAttack",
			"Bunker-Rocket-MRL",
			"GuardTower1",
		],
		[
			"GuardTower-ATMiss",
			"Bunker3-Rocket-AT3",
			"Tower2-Rocket-AT2",
			"PillBox6",
			"Bunker3-Rocket-Pod3Quad",
			"Bunker3-Rocket-Pod3Twin",
			"Bunker3-Rocket-Pod3",
			"GuardTower5",
			"Bunker2-Rocket-Pod2Quad",
			"Bunker2-Rocket-Pod2Twin",
			"Tower2-Rocket-Pod2",
			"Bunker-Rocket-PodQuad",
			"Bunker-Rocket-PodTwin",
			"Bunker-Rocket-Pod",
			"PillBox4",
		],
		[
			"Bunker3-Rocket-AT3",
			"Bunker3-Rocket-Pod3Quad",
			"Bunker3-Rocket-Pod3Twin",
			"Tower3-Rocket-Pod3",
			"Bunker2-Rocket-AT2",
			"Bunker2-Rocket-Pod2Quad",
			"Bunker2-Rocket-Pod2Twin",
			"Bunker2-Rocket-Pod2",
			"PillBox6",
			"Bunker-Rocket-PodQuad",
			"Bunker-Rocket-PodTwin",
			"GuardTower6",
			"PillBox1",
		],
		[
			"Super-MissileArrayPlas-Empl",
			"Super-MissileArray-Empl",
			"X-Super-Missile",
			"X-Super-Rocket",
		],
		];

		this.artillery = [
		[
			"Bunker3-Rocket-Archangel",
			"Bunker2-Rocket-Ripple",
		],
		];


		this.antiair = [
			"WallTower-SamHvy",
			"Bunker2-Rocket-SAM",
			"WallTower3-Rocket-Cherub",
			"Bunker-Rocket-Sunburst",
		];

		
		this.hardpoints = [
		[
			"WallTower-Atmiss",
			"WallTower-HvATrocket",
			"WallTower06",
			"WallTower3-Rocket-Pod3Quad",
			"WallTower3-Rocket-Pod3Twin",
			"WallTower3-Rocket-Pod3",
			"WallTower2-Rocket-Pod2Quad",
			"WallTower2-Rocket-Pod2Twin",
			"WallTower2-Rocket-Pod2",
			"WallTower-Rocket-PodQuad",
			"WallTower-Rocket-PodTwin",
			"WallTower-Rocket-Pod",
			"WallTower01",
		],
		[
			"WallTower-Atmiss",
			"WallTower3-Rocket-Pod3Quad",
			"WallTower3-Rocket-Pod3Twin",
			"WallTower3-Rocket-Pod3",
			"WallTower-HvATrocket",
			"WallTower2-Rocket-Pod2Quad",
			"WallTower2-Rocket-Pod2Twin",
			"WallTower2-Rocket-Pod2",
			"WallTower06",
			"WallTower-Rocket-PodQuad",
			"WallTower-Rocket-PodTwin",
			"WallTower-Rocket-Pod",
			"WallTower01",
		],
		];
		
		this.researchPathPrimary = [
			"R-Wpn-Cannon-Damage01",
			"R-Wpn-Rocket05-MiniPod",
			"R-Vehicle-Prop-Halftracks",
			"R-Vehicle-Body04",
			"R-Struc-PowerModuleMk1",
			"R-Wpn-Rocket02-MRL",
		];

		this.researchPathAT = [
			"R-Defense-Bunker-Cannon-Lgt",
			"R-Defense-Bunker-Rocket-Pod",
			"R-Defense-Tower-Rocket-Pod",
			"R-Defense-WallTower-Rocket-Pod",
			"R-Defense-Bunker-Rocket-PodTwin",
			"R-Defense-WallTower-Rocket-PodTwin",
			"R-Defense-Bunker-Rocket-PodQuad",
			"R-Defense-WallTower-Rocket-PodQuad",
			"R-Defense-Tower2-Rocket-Pod2",
			"R-Defense-Tower-Rocket-AT",
			"R-Defense-WallTower2-Rocket-Pod2",
			"R-Defense-WallTower2-Rocket-Pod2Twin",
			"R-Defense-WallTower2-Rocket-Pod2Quad",
			"R-Defense-Bunker2-Rocket-Pod2",
			"R-Defense-Bunker2-Rocket-Pod2Twin",
			"R-Defense-Bunker2-Rocket-Pod2Quad",
			"R-Defense-WallTower-Rocket-AT",
			"R-Defense-Super-Rocket",
			"R-Defense-Tower3-Rocket-Pod3",
			"R-Defense-WallTower3-Rocket-Pod3",
			"R-Defense-WallTower3-Rocket-Pod3Twin",
			"R-Defense-WallTower3-Rocket-Pod3Quad",
			"R-Defense-Bunker-Rocket-AT",
			"R-Defense-Bunker3-Rocket-Pod3",
			"R-Defense-WallTower2-Rocket-AT2",
			"R-Defense-Tower2-Rocket-AT2",
			"R-Defense-Bunker3-Rocket-Pod3Twin",
			"R-Defense-Bunker3-Rocket-Pod3Quad",
			"R-Defense-Bunker2-Rocket-AT2",
			"R-Defense-WallTower3-Rocket-AT3",
			"R-Defense-Bunker3-Rocket-AT3",
			"R-Defense-Super-Missile",
		];
		
		this.researchPathAP = [
			"R-Sys-SpyTurret",
			"R-Defense-Bunker-Rocket-MRL",
			"R-Defense-Bunker2-Rocket-TopAttack",
			"R-Defense-Bunker3-Rocket-Seraph",
		];
		
		this.researchPathAA = [
			"R-Defense-Bunker-Rocket-Sunburst",
			"R-Defense-WallTower3-Rocket-Cherub",
			"R-Defense-Bunker2-Rocket-SAM",
			"R-Defense-WallTower3-Rocket-SAM2",
		];
		
		this.researchPathAB = [
			"R-Wpn-Rocket03-HvAT",
			"R-Defense-Bunker2-Rocket-Ripple",
			"R-Wpn-Rocket-BB2",
			"R-Defense-Bunker3-Rocket-Archangel",
		];
		
	break;
	}
}

function buildOrder() {
	var labCount = enumStruct(me, lab).length;
	var factoryCount = enumStruct(me, factory).length;
	var commandCount = enumStruct(me, command).length;
	var genCount = enumStruct(me, generator).length;
	var derrickCount = enumStruct(me, derrick).length;
	var borgCount = enumStruct(me, borgfac).length;
	var vtolCount = enumStruct(me, vtolfac).length;
	if (genCount < 2 && playerPower(me) < EXTREME_LOW_POWER && isStructureAvailable(generator,me))
		return buildBasicStructure(generator);
	if (labCount < 1 && isStructureAvailable(lab,me))
		return buildBasicStructure(lab);
	if (factoryCount < 1 && isStructureAvailable(factory,me))
		return buildBasicStructure(factory);
	if (labCount < 2 && isStructureAvailable(lab,me))
		return buildBasicStructure(lab,0);
	if (commandCount < 1 && isStructureAvailable(command,me))
		return buildBasicStructure(command,0);
	if (factoryCount < 2 && isStructureAvailable(factory,me))
		return buildBasicStructure(factory,0);
	if ((genCount < 2) && isStructureAvailable(generator,me))
		return buildBasicStructure(generator);
	if (labCount < 3 && isStructureAvailable(lab,me))
		return buildBasicStructure(lab,0);
	if (borgCount < 2+(personality.subpersonality==1) && isStructureAvailable(borgfac,me))
		return buildBasicStructure(borgfac,0);
	if (vtolCount < 1 && isStructureAvailable(vtolfac,me)) 
		return buildBasicStructure(vtolfac,0);
	return false;
}
