//Set limits on unit and structure construction.
function setLimits() {
	for (var playnum = 0; playnum < maxPlayers; playnum++) {
		setStructureLimits("A0CommandCentre", 1, playnum);	// set structure limits
		setStructureLimits("A0LightFactory", 10, playnum);
		setStructureLimits("A0PowerGenerator", 64, playnum);
		setStructureLimits("A0ResearchFacility", 10, playnum);
		setStructureLimits("A0ComDroidControl", 128, playnum);
		setStructureLimits("A0CyborgFactory", 10, playnum);
		setStructureLimits("A0VTolFactory1", 10, playnum);
		setStructureLimits("A0LasSatCommand", 1, playnum);

		if (typeof(setDroidLimit)!="undefined") { 		//Only available for version 3.2
			setDroidLimit(playnum, 400);				//Only recommended if playing on matches with 4 players or less.
			setDroidLimit(playnum, 40, DROID_CONSTRUCT);	//40 construction droids seems a reasonable enough number on larger maps.
			setDroidLimit(playnum, 40, DROID_COMMAND);	//This should allow players to create enough commanders to handle more than 150 units at a time.
		}
	}
	applyLimitSet();	// set limit options as defined in multilim.slo and multilim.vlo, and on the game lobby settings.

	if (typeof(setDroidLimit)!="undefined") {
		setDroidLimit(scavengerPlayer, 400);
		setDroidLimit(scavengerPlayer, 40, DROID_CONSTRUCT);
		setDroidLimit(scavengerPlayer, 40, DROID_COMMAND);
	}
}