//Contingency has a built-in tier limiter. By default, this limiter is disabled. However, when other mods are loaded, the limiter can be set to disable T1 or T2 tech.
var tierLimit = 3;

//Complete and enable research
function setResearch() {
	var techListClean = new Array(
		"R-Vehicle-Prop-Wheels",
		"R-Sys-Spade1Mk1",
		"R-Vehicle-Body01",
		"R-Comp-SynapticLink");
	var techListBase = new Array(
		"R-Vehicle-Body04",
		"R-Wpn-MG1Mk1",
		"R-Defense-TankTrap01",
		"R-Defense-TankTrapGate",
		"R-Defense-TowerConst01",
		"R-Sys-Engineering01",
		"R-Vehicle-Prop-Halftracks",
		"R-Wpn-MG-Accuracy01",
		"R-Wpn-MG-Damage01",
		"R-Wpn-MG-ROF01",
		"R-Wpn-Cannon1Mk1",
		"R-Wpn-MG2Mk1",
		"R-Struc-RepairFacility",
		"R-Struc-PowerModuleMk1");
	var techListWalls = new Array(
		"R-Wpn-MG3Mk1",
		"R-Wpn-Cannon-Accuracy01",
		"R-Wpn-Flamer01Mk1",
		"R-Wpn-Rocket05-MiniPod",
		"R-Wpn-Mortar01Lt",
		"R-Vehicle-Engine01",
		"R-Sys-Sensor-Turret01",
		"R-Sys-MobileRepairTurret01",
		"R-Comp-CommandTurret01",
		"R-Struc-CommandRelay",
		"R-Defense-EmplConst01",
		"R-Defense-HardcreteWall",
		"R-Defense-HardcreteGate",
		"R-Defense-TowerConst02",
		"R-Defense-BunkerConst01",
		"R-Defense-WallTowerConst01",
		"R-Struc-Research-Module",
		"R-Struc-Factory-Module",
		"R-Struc-Factory-Cyborg",
		"R-Struc-Research-Upgrade01");

	for (var playnum = 0; playnum < maxPlayers; playnum++) {
		enableResearch("R-Vehicle-Body04", playnum);
		enableResearch("R-Vehicle-Prop-Halftracks", playnum);
		enableResearch("R-Defense-TankTrap01", playnum);
		enableResearch("R-Wpn-MG1Mk1", playnum);
		enableResearch("R-Sys-Engineering01", playnum);
		enableResearch("R-Defense-TowerConst01", playnum);

		if (tierLimit >= 3) {
			debug("All T3 technologies enabled.");
			completeResearch("R-T2Limiter",playnum);
		}
		else
			debug("All T3 technologies are locked");
		if (tierLimit >= 2) {
			debug("All T2 technologies enabled.");
			completeResearch("R-T1Limiter",playnum);
		}
		else
			debug("All T2 technologies are locked");
		
		for (var count = 0; count < techListClean.length; count++)
			completeResearch(techListClean[count], playnum);
		if (baseType == CAMP_BASE || baseType == CAMP_WALLS)
			for (var count = 0; count < techListBase.length; count++)
				completeResearch(techListBase[count], playnum);
		if (baseType == CAMP_WALLS)
			for (var count = 0; count < techListWalls.length; count++)
				completeResearch(techListWalls[count], playnum);
		
		if (playerData[playnum].difficulty == INSANE) //Give INSANE AIs the Engineering tech for free.
			completeResearch("R-Sys-Engineering01",playnum);
	}
}
